import { Properties } from './types';
export declare function optimisePerformanceData(performanceEntries: PerformanceResourceTiming[]): [] | [string[], any[]];
export declare function getPerformanceEntriesByType(type: string): any[][];
/**
 * https://developer.mozilla.org/en-US/docs/Web/API/Performance/getEntriesByType
 *
 *  The arrays in the prformance data are populated by getEntriesByType
 *  They contain PerformanceEntry objects for the given performance type.
 *  This means each object in the array shares a set of keys
 *
 * @param performanceEntries
 * @returns {(string[]|*)[]}
 */
export declare function deduplicateKeys(performanceEntries: PerformanceEntryList): [string[], any[]] | [];
export declare function pageLoadFrom(performanceData: {
    navigation: any[][];
    paint: any[][];
    resource: any[][];
}): number | void;
export declare function getPerformanceData(): Properties;
