var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
import { autocapture } from './autocapture';
import { _base64Encode } from './utils';
var Decide = /** @class */ (function () {
    function Decide(instance) {
        this.instance = instance;
        // don't need to wait for `decide` to return if flags were provided on initialisation
        this.instance.decideEndpointWasHit = this.instance._hasBootstrappedFeatureFlags();
    }
    Decide.prototype.call = function () {
        var _this = this;
        /*
        Calls /decide endpoint to fetch options for autocapture, session recording, feature flags & compression.
        */
        var json_data = JSON.stringify({
            token: this.instance.get_config('token'),
            distinct_id: this.instance.get_distinct_id(),
            groups: this.instance.getGroups(),
        });
        var encoded_data = _base64Encode(json_data);
        this.instance._send_request("".concat(this.instance.get_config('api_host'), "/decide/?v=2"), { data: encoded_data, verbose: true }, { method: 'POST' }, function (response) { return _this.parseDecideResponse(response); });
    };
    Decide.prototype.parseDecideResponse = function (response) {
        var e_1, _a, e_2, _b;
        var _this = this;
        var _c;
        if ((response === null || response === void 0 ? void 0 : response.status) === 0) {
            console.error('Failed to fetch feature flags from PostHog.');
            return;
        }
        this.instance.decideEndpointWasHit = true;
        if (!(document && document.body)) {
            console.log('document not ready yet, trying again in 500 milliseconds...');
            setTimeout(function () {
                _this.parseDecideResponse(response);
            }, 500);
            return;
        }
        this.instance.toolbar.afterDecideResponse(response);
        (_c = this.instance.sessionRecording) === null || _c === void 0 ? void 0 : _c.afterDecideResponse(response);
        autocapture.afterDecideResponse(response, this.instance);
        this.instance.featureFlags.receivedFeatureFlags(response);
        if (response['supportedCompression']) {
            var compression = {};
            try {
                for (var _d = __values(response['supportedCompression']), _e = _d.next(); !_e.done; _e = _d.next()) {
                    var method = _e.value;
                    compression[method] = true;
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_e && !_e.done && (_a = _d.return)) _a.call(_d);
                }
                finally { if (e_1) throw e_1.error; }
            }
            this.instance['compression'] = compression;
        }
        else {
            this.instance['compression'] = {};
        }
        if (response['siteApps']) {
            if (this.instance.get_config('opt_in_site_apps')) {
                var apiHost = this.instance.get_config('api_host');
                var _loop_1 = function (id, url) {
                    var script = document.createElement('script');
                    script.src = [
                        apiHost,
                        apiHost[apiHost.length - 1] === '/' && url[0] === '/' ? url.substring(1) : url,
                    ].join('');
                    script.onerror = function (e) {
                        console.error("Error while initializing PostHog app with config id ".concat(id), e);
                    };
                    window["__$$ph_site_app_".concat(id)] = this_1.instance;
                    document.body.appendChild(script);
                };
                var this_1 = this;
                try {
                    for (var _f = __values(response['siteApps']), _g = _f.next(); !_g.done; _g = _f.next()) {
                        var _h = _g.value, id = _h.id, url = _h.url;
                        _loop_1(id, url);
                    }
                }
                catch (e_2_1) { e_2 = { error: e_2_1 }; }
                finally {
                    try {
                        if (_g && !_g.done && (_b = _f.return)) _b.call(_f);
                    }
                    finally { if (e_2) throw e_2.error; }
                }
            }
            else if (response['siteApps'].length > 0) {
                console.error('PostHog site apps are disabled. Enable the "opt_in_site_apps" config to proceed.');
            }
        }
    };
    return Decide;
}());
export { Decide };
//# sourceMappingURL=decide.js.map