import { PostHog } from '../posthog-core';
import { DecideResponse, EditorParams } from '../types';
export declare class Toolbar {
    instance: PostHog;
    constructor(instance: PostHog);
    afterDecideResponse(response: DecideResponse): void;
    /**
     * To load the visual editor, we need an access token and other state. That state comes from one of three places:
     * 1. In the URL hash params if the customer is using an old snippet
     * 2. From session storage under the key `editorParams` if the editor was initialized on a previous page
     */
    maybeLoadEditor(location?: Location, localStorage?: Storage | undefined, history?: History): boolean;
    _loadEditor(editorParams: EditorParams): boolean;
}
